diff -Nur --exclude=.svn src/backends/odbc/test/Makefile.am soci/backends/odbc/test/Makefile.am
--- src/backends/odbc/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/odbc/test/Makefile.am	2009-04-19 23:54:42.000000000 +0200
@@ -1,57 +1,45 @@
-# $Id: Makefile.am,v 1.2 2008/05/12 13:21:25 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = @BOOST_CPPFLAGS@ @ODBC_CFLAGS@
-AM_LDFLAGS = @ODBC_LDFLAGS@
-
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/core/test \
-	-I$(top_srcdir)/src/backends/odbc
-
-noinst_PROGRAMS = \
-	test_odbc_access \
-	test_odbc_mssql \
-	test_odbc_mysql \
-	test_odbc_postgresql
-
-test_odbc_access_SOURCES = \
-	test-odbc-access.cpp
-
-test_odbc_mssql_SOURCES = \
-	test-odbc-mssql.cpp
-
-test_odbc_mysql_SOURCES = \
-	test-odbc-mysql.cpp
-
-test_odbc_postgresql_SOURCES = \
-	test-odbc-postgresql.cpp
-
-test_odbc_access_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/odbc/lib@SOCI_ODBC_LIBRARY_NAME@.la
-
-test_odbc_mssql_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/odbc/lib@SOCI_ODBC_LIBRARY_NAME@.la
-
-test_odbc_mysql_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/odbc/lib@SOCI_ODBC_LIBRARY_NAME@.la
-
-test_odbc_postgresql_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/odbc/lib@SOCI_ODBC_LIBRARY_NAME@.la
-
-EXTRA_DIST = \
-	Makefile.basic \
-	test-access.dsn \
-	test-mssql.dsn \
-	test-mysql.dsn \
-	test-postgresql.dsn
+## backends/odbc/test sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic makefile.msvc \
+	test-access.dsn test-mssql.dsn test-mysql.dsn test-postgresql.dsn
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+if RUN_TESTS
+  noinst_PROGRAMS = test_odbc_access test_odbc_mssql \
+	test_odbc_mysql test_odbc_postgresql
+endif
+
+test_odbc_access_SOURCES = $(odbc_access_test_cc_sources)
+test_odbc_access_CXXFLAGS = $(BOOST_CFLAGS)
+test_odbc_access_LDADD =
+test_odbc_access_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/odbc/libsoci_odbc.la \
+		$(ODBC_LDFLAGS)
+
+test_odbc_mssql_SOURCES = $(odbc_mssql_test_cc_sources)
+test_odbc_mssql_CXXFLAGS = $(BOOST_CFLAGS)
+test_odbc_mssql_LDADD =
+test_odbc_mssql_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/odbc/libsoci_odbc.la \
+		$(ODBC_LDFLAGS)
+
+test_odbc_mysql_SOURCES = $(odbc_mysql_test_cc_sources)
+test_odbc_mysql_CXXFLAGS = $(BOOST_CFLAGS)
+test_odbc_mysql_LDADD =
+test_odbc_mysql_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/odbc/libsoci_odbc.la \
+		$(ODBC_LDFLAGS)
+
+test_odbc_postgresql_SOURCES = $(odbc_postgresql_test_cc_sources)
+test_odbc_postgresql_CXXFLAGS = $(BOOST_CFLAGS)
+test_odbc_postgresql_LDADD =
+test_odbc_postgresql_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/odbc/libsoci_odbc.la \
+		$(ODBC_LDFLAGS)
 
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+#nodist_pkginclude_HEADERS = $(odbc_test_h_sources)
diff -Nur --exclude=.svn src/backends/odbc/test/sources.mk soci/backends/odbc/test/sources.mk
--- src/backends/odbc/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/odbc/test/sources.mk	2009-04-19 23:20:55.000000000 +0200
@@ -0,0 +1,8 @@
+odbc_access_test_h_sources =
+odbc_access_test_cc_sources = $(top_srcdir)/soci/backends/odbc/test/test-odbc-access.cpp
+odbc_mssql_test_h_sources =
+odbc_mssql_test_cc_sources = $(top_srcdir)/soci/backends/odbc/test/test-odbc-mssql.cpp
+odbc_mysql_test_h_sources =
+odbc_mysql_test_cc_sources = $(top_srcdir)/soci/backends/odbc/test/test-odbc-mysql.cpp
+odbc_postgresql_test_h_sources =
+odbc_postgresql_test_cc_sources = $(top_srcdir)/soci/backends/odbc/test/test-odbc-postgresql.cpp
diff -Nur --exclude=.svn src/backends/oracle/blob.cpp soci/backends/oracle/blob.cpp
--- src/backends/oracle/blob.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/blob.cpp	2009-04-05 17:23:36.000000000 +0200
@@ -7,7 +7,13 @@
 
 #include "soci-oracle.h"
 #include "error.h"
-#include "statement.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/statement.h>
+#else
+#	include <statement.h>
+#endif
+//
 #include <cstring>
 #include <sstream>
 #include <cstdio>
diff -Nur --exclude=.svn src/backends/oracle/Makefile.am soci/backends/oracle/Makefile.am
--- src/backends/oracle/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/Makefile.am	2009-04-19 01:57:10.000000000 +0200
@@ -1,41 +1,31 @@
-# $Id: Makefile.am,v 1.4 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-AM_CPPFLAGS = @ORACLE_OCI_CFLAGS@
-
-lib_LTLIBRARIES	= \
-	lib@SOCI_ORACLE_LIBRARY_NAME@.la
-
-lib@SOCI_ORACLE_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @ORACLE_OCI_LDFLAGS@
-
-lib@SOCI_ORACLE_LIBRARY_NAME@_la_LIBADD = \
-	@top_builddir@/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_ORACLE_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	error.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-soci_oracledir = $(includedir)/soci/oracle
-
-soci_oracle_HEADERS = \
-	error.h \
-	soci-oracle.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/oracle sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+if HAVE_ORACLE
+lib_LTLIBRARIES= libsoci_oracle.la
+
+libsoci_oracle_la_SOURCES= $(bck_oracle_h_sources) $(bck_oracle_cc_sources) 
+libsoci_oracle_la_CXXFLAGS = $(ORACLE_OCI_CFLAGS)
+libsoci_oracle_la_LIBADD =
+libsoci_oracle_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	$(ORACLE_OCI_LDFLAGS) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+nobase_pkginclude_HEADERS = $(top_srcdir)/soci/backends/oracle/soci-oracle.h
+endif
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/oracle
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/oracle/soci-oracle.h soci/backends/oracle/soci-oracle.h
--- src/backends/oracle/soci-oracle.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/soci-oracle.h	2009-04-05 17:07:42.000000000 +0200
@@ -22,9 +22,14 @@
 #ifndef SOCI_ORACLE_DECL
 # define SOCI_ORACLE_DECL
 #endif
-
-#include <soci-backend.h>
-#include <oci.h> // OCI
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
+//
+#include <oci.h> // OCI (Oracle client)
 #include <vector>
 
 #ifdef _MSC_VER
diff -Nur --exclude=.svn src/backends/oracle/sources.mk soci/backends/oracle/sources.mk
--- src/backends/oracle/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/oracle/sources.mk	2009-03-28 15:22:29.000000000 +0100
@@ -0,0 +1,14 @@
+bck_oracle_h_sources = \
+        $(top_srcdir)/soci/backends/oracle/error.h \
+        $(top_srcdir)/soci/backends/oracle/soci-oracle.h
+bck_oracle_cc_sources = \
+        $(top_srcdir)/soci/backends/oracle/blob.cpp \
+        $(top_srcdir)/soci/backends/oracle/error.cpp \
+        $(top_srcdir)/soci/backends/oracle/factory.cpp \
+        $(top_srcdir)/soci/backends/oracle/row-id.cpp \
+        $(top_srcdir)/soci/backends/oracle/session.cpp \
+        $(top_srcdir)/soci/backends/oracle/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/oracle/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/oracle/statement.cpp \
+        $(top_srcdir)/soci/backends/oracle/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/oracle/vector-use-type.cpp
diff -Nur --exclude=.svn src/backends/oracle/standard-into-type.cpp soci/backends/oracle/standard-into-type.cpp
--- src/backends/oracle/standard-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/standard-into-type.cpp	2009-04-19 16:07:20.000000000 +0200
@@ -7,10 +7,18 @@
 
 #define SOCI_ORACLE_SOURCE
 #include "soci-oracle.h"
-#include "blob.h"
 #include "error.h"
-#include "rowid.h"
-#include "statement.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/blob.h>
+#       include <soci/core/rowid.h>
+#       include <soci/core/statement.h>
+#else
+#       include <blob.h>
+#       include <rowid.h>
+#       include <statement.h>
+#endif
+//
 #include <cctype>
 #include <cstdio>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/oracle/standard-use-type.cpp soci/backends/oracle/standard-use-type.cpp
--- src/backends/oracle/standard-use-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/standard-use-type.cpp	2009-04-19 16:08:52.000000000 +0200
@@ -7,10 +7,18 @@
 
 #define soci_ORACLE_SOURCE
 #include "soci-oracle.h"
-#include "blob.h"
 #include "error.h"
-#include "rowid.h"
-#include "statement.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/blob.h>
+#       include <soci/core/rowid.h>
+#       include <soci/core/statement.h>
+#else
+#       include <blob.h>
+#       include <rowid.h>
+#       include <statement.h>
+#endif
+//
 #include <cctype>
 #include <cstdio>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/oracle/statement.cpp soci/backends/oracle/statement.cpp
--- src/backends/oracle/statement.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/statement.cpp	2009-04-05 17:22:06.000000000 +0200
@@ -9,7 +9,13 @@
 
 #include "soci-oracle.h"
 #include "error.h"
-#include <soci-backend.h>
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
+//
 #include <cctype>
 #include <cstdio>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/oracle/test/Makefile.am soci/backends/oracle/test/Makefile.am
--- src/backends/oracle/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/test/Makefile.am	2009-04-19 01:57:20.000000000 +0200
@@ -1,28 +1,26 @@
-# $Id: Makefile.am,v 1.6 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = @BOOST_CPPFLAGS@ @ORACLE_OCI_CFLAGS@
-AM_LDFLAGS = @ORACLE_OCI_LDFLAGS@
-
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/core/test \
-	-I$(top_srcdir)/src/backends/oracle
-
-noinst_PROGRAMS = \
-	test_oracle
-
-test_oracle_SOURCES = \
-	test-oracle.cpp
-
-test_oracle_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/oracle/lib@SOCI_ORACLE_LIBRARY_NAME@.la
+## core sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-EXTRA_DIST = Makefile.basic
+MAINTAINERCLEANFILES = Makefile.in
 
-MAINTAINERCLEANLOCAL = Makefile.in
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
 
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+if HAVE_ORACLE
+  TEST_ORACLE = test_oracle
+
+if RUN_TESTS
+  noinst_PROGRAMS = $(TEST_ORACLE)
+endif
+
+test_oracle_SOURCES = $(oracle_test_cc_sources)
+test_oracle_CXXFLAGS = $(BOOST_CFLAGS) $(ORACLE_OCI_CFLAGS)
+test_oracle_LDADD =
+test_oracle_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/oracle/libsoci_oracle.la \
+		$(ORACLE_OCI_LDFLAGS)
+endif
+
+#nodist_pkginclude_HEADERS = $(oracle_test_h_sources)
diff -Nur --exclude=.svn src/backends/oracle/test/sources.mk soci/backends/oracle/test/sources.mk
--- src/backends/oracle/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/oracle/test/sources.mk	2009-04-09 23:30:41.000000000 +0200
@@ -0,0 +1,2 @@
+oracle_test_h_sources =
+oracle_test_cc_sources = $(top_srcdir)/soci/backends/oracle/test/test-oracle.cpp
diff -Nur --exclude=.svn src/backends/oracle/test/test-oracle.cpp soci/backends/oracle/test/test-oracle.cpp
--- src/backends/oracle/test/test-oracle.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/test/test-oracle.cpp	2009-04-19 16:16:17.000000000 +0200
@@ -5,9 +5,17 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include "soci.h"
-#include "soci-oracle.h"
-#include "common-tests.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci.h>
+#       include <soci/backends/oracle/soci-oracle.h>
+#       include <soci/core/test/common-tests.h>
+#else
+#	include <soci.h>
+#	include <soci-oracle.h>
+#       include <test/common-tests.h>
+#endif
+//
 #include <iostream>
 #include <string>
 #include <cassert>
diff -Nur --exclude=.svn src/backends/oracle/vector-into-type.cpp soci/backends/oracle/vector-into-type.cpp
--- src/backends/oracle/vector-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/oracle/vector-into-type.cpp	2009-04-19 16:25:30.000000000 +0200
@@ -7,8 +7,14 @@
 
 #define soci_ORACLE_SOURCE
 #include "soci-oracle.h"
-#include "statement.h"
 #include "error.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/statement.h>
+#else
+#	include <statement.h>
+#endif
+//
 #include <cctype>
 #include <cstdio>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/postgresql/common.cpp soci/backends/postgresql/common.cpp
--- src/backends/postgresql/common.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/common.cpp	2009-04-05 17:27:50.000000000 +0200
@@ -6,7 +6,13 @@
 //
 
 #include "common.h"
-#include <soci-backend.h>
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
+//
 #include <cstdlib>
 #include <ctime>
 
diff -Nur --exclude=.svn src/backends/postgresql/Makefile.am soci/backends/postgresql/Makefile.am
--- src/backends/postgresql/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/Makefile.am	2009-04-19 02:53:20.000000000 +0200
@@ -1,41 +1,31 @@
-# $Id: Makefile.am,v 1.4 2008/04/28 19:58:54 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-AM_CPPFLAGS = @POSTGRESQL_CFLAGS@
-
-lib_LTLIBRARIES	= \
-	lib@SOCI_POSTGRESQL_LIBRARY_NAME@.la
-
-lib@SOCI_POSTGRESQL_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @POSTGRESQL_LDFLAGS@
-
-lib@SOCI_POSTGRESQL_LIBRARY_NAME@_la_LIBADD = \
-	@top_builddir@/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_POSTGRESQL_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	common.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-soci_postgresqldir = $(includedir)/soci/postgresql
-
-soci_postgresql_HEADERS = \
-	common.h \
-	soci-postgresql.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/postgresql sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+#EXTRA_DIST_FOR_SOCI_COMPATIBILITY = ._common.h
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+if HAVE_POSTGRESQL
+lib_LTLIBRARIES= libsoci_postgresql.la
+
+libsoci_postgresql_la_SOURCES= $(bck_postgresql_h_sources) $(bck_postgresql_cc_sources) 
+libsoci_postgresql_la_CXXFLAGS = $(POSTGRESQL_CFLAGS)
+libsoci_postgresql_la_LIBADD =
+libsoci_postgresql_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(top_srcdir)/soci/backends/postgresql/soci-postgresql.h
+endif
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/postgresql
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/postgresql/soci-postgresql.h soci/backends/postgresql/soci-postgresql.h
--- src/backends/postgresql/soci-postgresql.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/soci-postgresql.h	2009-04-05 17:07:18.000000000 +0200
@@ -22,9 +22,14 @@
 #ifndef SOCI_POSTGRESQL_DECL
 # define SOCI_POSTGRESQL_DECL
 #endif
-
-#include <soci-backend.h>
-#include <libpq-fe.h>
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
+//
+#include <libpq-fe.h> // PostGreSQL client
 #include <vector>
 
 #ifdef _MSC_VER
diff -Nur --exclude=.svn src/backends/postgresql/sources.mk soci/backends/postgresql/sources.mk
--- src/backends/postgresql/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/postgresql/sources.mk	2009-03-28 18:57:02.000000000 +0100
@@ -0,0 +1,14 @@
+bck_postgresql_h_sources = \
+        $(top_srcdir)/soci/backends/postgresql/common.h \
+        $(top_srcdir)/soci/backends/postgresql/soci-postgresql.h
+bck_postgresql_cc_sources = \
+        $(top_srcdir)/soci/backends/postgresql/blob.cpp \
+        $(top_srcdir)/soci/backends/postgresql/common.cpp \
+        $(top_srcdir)/soci/backends/postgresql/factory.cpp \
+        $(top_srcdir)/soci/backends/postgresql/row-id.cpp \
+        $(top_srcdir)/soci/backends/postgresql/session.cpp \
+        $(top_srcdir)/soci/backends/postgresql/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/postgresql/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/postgresql/statement.cpp \
+        $(top_srcdir)/soci/backends/postgresql/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/postgresql/vector-use-type.cpp
diff -Nur --exclude=.svn src/backends/postgresql/standard-into-type.cpp soci/backends/postgresql/standard-into-type.cpp
--- src/backends/postgresql/standard-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/standard-into-type.cpp	2009-04-19 16:28:44.000000000 +0200
@@ -8,9 +8,16 @@
 #define SOCI_POSTGRESQL_SOURCE
 #include "soci-postgresql.h"
 #include "common.h"
-#include "rowid.h"
-#include "blob.h"
-#include <libpq/libpq-fs.h> // libpq
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/blob.h>
+#       include <soci/core/rowid.h>
+#else
+#       include <blob.h>
+#       include <rowid.h>
+#endif
+//
+#include <libpq/libpq-fs.h> // libpq (PostGreSQL client)
 #include <cctype>
 #include <cstdio>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/postgresql/standard-use-type.cpp soci/backends/postgresql/standard-use-type.cpp
--- src/backends/postgresql/standard-use-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/standard-use-type.cpp	2009-04-19 16:29:14.000000000 +0200
@@ -7,8 +7,14 @@
 
 #define SOCI_POSTGRESQL_SOURCE
 #include "soci-postgresql.h"
-#include "rowid.h"
-#include <libpq/libpq-fs.h> // libpq
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/rowid.h>
+#else
+#       include <rowid.h>
+#endif
+//
+#include <libpq/libpq-fs.h> // libpq (PostGreSQL client)
 #include <cctype>
 #include <cstdio>
 #include <cstring>
diff -Nur --exclude=.svn src/backends/postgresql/test/Makefile.am soci/backends/postgresql/test/Makefile.am
--- src/backends/postgresql/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/test/Makefile.am	2009-04-19 01:55:28.000000000 +0200
@@ -1,28 +1,22 @@
-# $Id: Makefile.am,v 1.6 2008/04/28 19:58:55 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = @BOOST_CPPFLAGS@ @POSTGRESQL_CFLAGS@
-AM_LDFLAGS = @POSTGRESQL_LDFLAGS@
-
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/core/test \
-	-I$(top_srcdir)/src/backends/postgresql
-
-noinst_PROGRAMS = \
-	test_postgresql
-
-test_postgresql_SOURCES = \
-	test-postgresql.cpp
-
-test_postgresql_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/postgresql/lib@SOCI_POSTGRESQL_LIBRARY_NAME@.la
+## backends/postgresql/test sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-EXTRA_DIST = Makefile.basic
+MAINTAINERCLEANFILES = Makefile.in
 
-MAINTAINERCLEANLOCAL = Makefile.in
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
 
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+if RUN_TESTS
+  noinst_PROGRAMS = test_postgresql
+endif
+
+test_postgresql_SOURCES = $(postgresql_test_cc_sources)
+test_postgresql_CXXFLAGS = $(BOOST_CFLAGS)
+test_postgresql_LDADD =
+test_postgresql_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/postgresql/libsoci_postgresql.la \
+		$(POSTGRESQL_LDFLAGS)
+
+#nodist_pkginclude_HEADERS = $(postgresql_test_h_sources)
diff -Nur --exclude=.svn src/backends/postgresql/test/sources.mk soci/backends/postgresql/test/sources.mk
--- src/backends/postgresql/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/postgresql/test/sources.mk	2009-04-09 00:07:41.000000000 +0200
@@ -0,0 +1,2 @@
+postgresql_test_h_sources =
+postgresql_test_cc_sources = $(top_srcdir)/soci/backends/postgresql/test/test-postgresql.cpp
diff -Nur --exclude=.svn src/backends/postgresql/test/test-postgresql.cpp soci/backends/postgresql/test/test-postgresql.cpp
--- src/backends/postgresql/test/test-postgresql.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/postgresql/test/test-postgresql.cpp	2009-04-19 16:36:24.000000000 +0200
@@ -5,9 +5,17 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include "soci.h"
-#include "soci-postgresql.h"
-#include "common-tests.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci.h>
+#       include <soci/backends/postgresql/soci-postgresql.h>
+#       include <soci/core/test/common-tests.h>
+#else
+#	include <soci.h>
+#	include <soci-postgresql.h>
+#       include <test/common-tests.h>
+#endif
+//
 #include <iostream>
 #include <sstream>
 #include <string>
diff -Nur --exclude=.svn src/backends/sqlite3/common.cpp soci/backends/sqlite3/common.cpp
--- src/backends/sqlite3/common.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/common.cpp	2009-04-19 21:47:22.000000000 +0200
@@ -6,7 +6,12 @@
 //
 
 #include "common.h"
-#include "soci-backend.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
 // std
 #include <cstdlib>
 #include <ctime>
@@ -64,4 +69,3 @@
 
     std::mktime(&t);
 }
-
diff -Nur --exclude=.svn src/backends/sqlite3/Makefile.am soci/backends/sqlite3/Makefile.am
--- src/backends/sqlite3/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/Makefile.am	2009-04-19 02:53:39.000000000 +0200
@@ -1,41 +1,30 @@
-# $Id: Makefile.am,v 1.4 2008/04/28 19:58:55 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-INCLUDES = -I$(top_srcdir)/src/core
-AM_CXXFLAGS = -fPIC
-AM_CPPFLAGS = @SQLITE3_CFLAGS@
-
-lib_LTLIBRARIES	= \
-	lib@SOCI_SQLITE3_LIBRARY_NAME@.la
-
-lib@SOCI_SQLITE3_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @SQLITE3_LDFLAGS@
-
-lib@SOCI_SQLITE3_LIBRARY_NAME@_la_LIBADD = \
-	@top_builddir@/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_SQLITE3_LIBRARY_NAME@_la_SOURCES = \
-	blob.cpp \
-	common.cpp \
-	factory.cpp \
-	row-id.cpp \
-	session.cpp \
-	standard-into-type.cpp \
-	standard-use-type.cpp \
-	statement.cpp \
-	vector-into-type.cpp \
-	vector-use-type.cpp
-
-soci_sqlite3dir = $(includedir)/soci/sqlite3
-
-soci_sqlite3_HEADERS = \
-	common.h \
-	soci-sqlite3.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## backends/postgresql sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+if HAVE_SQLITE3
+lib_LTLIBRARIES= libsoci_sqlite3.la
+
+libsoci_sqlite3_la_SOURCES= $(bck_sqlite3_h_sources) $(bck_sqlite3_cc_sources) 
+libsoci_sqlite3_la_CXXFLAGS = $(SQLITE3_CFLAGS)
+libsoci_sqlite3_la_LIBADD =
+libsoci_sqlite3_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(top_srcdir)/soci/backends/sqlite3/soci-sqlite3.h
+endif
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/backends/sqlite3
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/backends/sqlite3/soci-sqlite3.h soci/backends/sqlite3/soci-sqlite3.h
--- src/backends/sqlite3/soci-sqlite3.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/soci-sqlite3.h	2009-04-19 03:23:01.000000000 +0200
@@ -24,7 +24,12 @@
 #endif
 
 #include <vector>
-#include "soci-backend.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-backend.h>
+#else
+#	include <soci-backend.h>
+#endif
 
 // Disable flood of nonsense warnings generated for SQLite
 #ifdef _MSC_VER
diff -Nur --exclude=.svn src/backends/sqlite3/sources.mk soci/backends/sqlite3/sources.mk
--- src/backends/sqlite3/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/sqlite3/sources.mk	2009-03-30 23:42:07.000000000 +0200
@@ -0,0 +1,14 @@
+bck_sqlite3_h_sources = \
+        $(top_srcdir)/soci/backends/sqlite3/common.h \
+        $(top_srcdir)/soci/backends/sqlite3/soci-sqlite3.h
+bck_sqlite3_cc_sources = \
+        $(top_srcdir)/soci/backends/sqlite3/blob.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/common.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/factory.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/row-id.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/session.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/standard-into-type.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/standard-use-type.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/statement.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/vector-into-type.cpp \
+        $(top_srcdir)/soci/backends/sqlite3/vector-use-type.cpp
diff -Nur --exclude=.svn src/backends/sqlite3/standard-into-type.cpp soci/backends/sqlite3/standard-into-type.cpp
--- src/backends/sqlite3/standard-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/standard-into-type.cpp	2009-04-19 21:45:34.000000000 +0200
@@ -5,11 +5,18 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include <soci-platform.h>
 #include "soci-sqlite3.h"
-#include "rowid.h"
 #include "common.h"
-#include "blob.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-platform.h>
+#       include <soci/core/rowid.h>
+#       include <soci/core/blob.h>
+#else
+#	include <soci-platform.h>
+#	include <rowid.h>
+#	include <blob.h>
+#endif
 // std
 #include <cstdlib>
 #include <ctime>
diff -Nur --exclude=.svn src/backends/sqlite3/standard-use-type.cpp soci/backends/sqlite3/standard-use-type.cpp
--- src/backends/sqlite3/standard-use-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/standard-use-type.cpp	2009-04-19 03:27:09.000000000 +0200
@@ -7,9 +7,16 @@
 
 
 #include "soci-sqlite3.h"
-#include "rowid.h"
-#include "blob.h"
-// std
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/rowid.h>
+#       include <soci/core/blob.h>
+#else
+#	include <rowid.h>
+#	include <blob.h>
+#endif
+//
+// STL
 #include <cstring>
 #include <ctime>
 #include <limits>
diff -Nur --exclude=.svn src/backends/sqlite3/test/Makefile.am soci/backends/sqlite3/test/Makefile.am
--- src/backends/sqlite3/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/test/Makefile.am	2009-04-19 02:55:55.000000000 +0200
@@ -1,40 +1,22 @@
-# $Id: Makefile.am,v 1.6 2008/04/28 19:58:55 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = @BOOST_CPPFLAGS@ @SQLITE3_CFLAGS@
-AM_LDFLAGS = @SQLITE3_LDFLAGS@
-
-INCLUDES = \
-	-I$(top_srcdir)/src/core \
-	-I$(top_srcdir)/src/core/test \
-	-I$(top_srcdir)/src/backends/sqlite3
-
-TEST_CASE = test_sqlite3
-TEST_DB = test_sqlite3.db
-
-noinst_PROGRAMS = \
-	$(TEST_CASE)
-
-#test_sqlite3_CPPFLAGS = \
-#	-DSQLITE_ENABLE_COLUMN_METADATA
-
-test_sqlite3_SOURCES = \
-	test-sqlite3.cpp
-
-test_sqlite3_LDADD = \
-	$(top_builddir)/src/core/lib@SOCI_CORE_LIBRARY_NAME@.la \
-	$(top_builddir)/src/backends/sqlite3/lib@SOCI_SQLITE3_LIBRARY_NAME@.la
-
-EXTRA_DIST = Makefile.basic
-
-check-local:
-	$(SHELL) -x $(TEST_CASE) $(TEST_DB)
-
-clean-local:
-	$(RM) $(TEST_DB)
-	
-MAINTAINERCLEANLOCAL = Makefile.in
+## backends/sqlite3/test sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+MAINTAINERCLEANFILES = Makefile.in
+
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+if RUN_TESTS
+  noinst_PROGRAMS = test_sqlite3
+endif
+
+test_sqlite3_SOURCES = $(sqlite3_test_cc_sources)
+test_sqlite3_CXXFLAGS = $(BOOST_CFLAGS)
+test_sqlite3_LDADD =
+test_sqlite3_LDFLAGS = $(top_builddir)/soci/core/libsoci_core.la -ldl \
+		$(top_builddir)/soci/backends/sqlite3/libsoci_sqlite3.la \
+		$(SQLITE3_LDFLAGS)
+
+#nodist_pkginclude_HEADERS = $(sqlite3_test_h_sources)
diff -Nur --exclude=.svn src/backends/sqlite3/test/sources.mk soci/backends/sqlite3/test/sources.mk
--- src/backends/sqlite3/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/backends/sqlite3/test/sources.mk	2009-04-19 02:56:11.000000000 +0200
@@ -0,0 +1,2 @@
+sqlite3_test_h_sources =
+sqlite3_test_cc_sources = $(top_srcdir)/soci/backends/sqlite3/test/test-sqlite3.cpp
diff -Nur --exclude=.svn src/backends/sqlite3/test/test-sqlite3.cpp soci/backends/sqlite3/test/test-sqlite3.cpp
--- src/backends/sqlite3/test/test-sqlite3.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/test/test-sqlite3.cpp	2009-04-19 03:28:39.000000000 +0200
@@ -5,9 +5,17 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include "soci.h"
-#include "soci-sqlite3.h"
-#include "common-tests.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci.h>
+#       include <soci/backends/sqlite3/soci-sqlite3.h>
+#       include <soci/core/test/common-tests.h>
+#else
+#	include <soci.h>
+#	include <soci-sqlite3.h>
+#       include <test/common-tests.h>
+#endif
+//
 #include <iostream>
 #include <sstream>
 #include <string>
diff -Nur --exclude=.svn src/backends/sqlite3/vector-into-type.cpp soci/backends/sqlite3/vector-into-type.cpp
--- src/backends/sqlite3/vector-into-type.cpp	2009-04-19 22:58:52.000000000 +0200
+++ soci/backends/sqlite3/vector-into-type.cpp	2009-04-19 21:43:19.000000000 +0200
@@ -5,9 +5,14 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 //
 
-#include <soci-platform.h>
 #include "soci-sqlite3.h"
 #include "common.h"
+//
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci-platform.h>
+#else
+#       include <soci-platform.h>
+#endif
 // std
 #include <cstddef>
 #include <cstdlib>
